'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _partial = require('ramda/src/partial');

var _partial2 = _interopRequireDefault(_partial);

var _over = require('ramda/src/over');

var _over2 = _interopRequireDefault(_over);

var _forEachObjIndexed = require('ramda/src/forEachObjIndexed');

var _forEachObjIndexed2 = _interopRequireDefault(_forEachObjIndexed);

var _view = require('ramda/src/view');

var _view2 = _interopRequireDefault(_view);

var _last = require('ramda/src/last');

var _last2 = _interopRequireDefault(_last);

var _has = require('ramda/src/has');

var _has2 = _interopRequireDefault(_has);

var _path = require('ramda/src/path');

var _path2 = _interopRequireDefault(_path);

var _init = require('ramda/src/init');

var _init2 = _interopRequireDefault(_init);

var _complement = require('ramda/src/complement');

var _complement2 = _interopRequireDefault(_complement);

var _lensPath = require('ramda/src/lensPath');

var _lensPath2 = _interopRequireDefault(_lensPath);

var _map = require('ramda/src/map');

var _map2 = _interopRequireDefault(_map);

var _isEmpty = require('ramda/src/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _reject = require('ramda/src/reject');

var _reject2 = _interopRequireDefault(_reject);

var _split = require('ramda/src/split');

var _split2 = _interopRequireDefault(_split);

var _pipe = require('ramda/src/pipe');

var _pipe2 = _interopRequireDefault(_pipe);

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _paths = require('./paths');

var _paths2 = _interopRequireDefault(_paths);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var toPath = (0, _pipe2.default)((0, _split2.default)(/[^\w\d]+/g), (0, _reject2.default)(_isEmpty2.default));

var edgeToTransformation = function edgeToTransformation(_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      fRawPath = _ref2[0],
      depRawPaths = _ref2[1];

  var fPath = toPath(fRawPath);
  var depPaths = (0, _map2.default)(toPath, depRawPaths);
  var fLens = (0, _lensPath2.default)(fPath);

  return function (graph) {
    // Start of debug
    if (process.env.NODE_ENV !== 'production') {
      // Util functions we will need but only in non-prod
      var isPopulated = (0, _complement2.default)(_isEmpty2.default);
      var isDependencyInGraph = function isDependencyInGraph(depPath, graph) {
        return (0, _pipe2.default)(_init2.default, function (x) {
          return (0, _path2.default)(x)(graph);
        }, (0, _has2.default)((0, _last2.default)(depPath)))(depPath);
      };

      // Check that the key exists for the func
      (0, _invariant2.default)(typeof (0, _view2.default)(fLens)(graph) === 'function', 'Function [' + fRawPath + '] not found in graph');

      // Check that the dep exists
      // It is important to note that a dep could be
      // null or undefined. Therefore we need to check the key
      // not the value
      (0, _forEachObjIndexed2.default)(function (depPath, idx) {
        (0, _invariant2.default)(isPopulated(depPath), 'Empty path at index [' + idx + '] for [' + fRawPath + ']');

        (0, _invariant2.default)(isDependencyInGraph(depPath, graph), 'Dependency [' + depRawPaths[idx] + '] for [' + fRawPath + '] not found in graph');
      })(depPaths);
    }
    // End of debug
    return (0, _over2.default)(fLens, function (f) {
      return (0, _partial2.default)(f, (0, _paths2.default)(depPaths, graph));
    }, graph);
  };
};

var mapEdgesToTransformations = (0, _map2.default)(edgeToTransformation);

exports.default = function (edges, graph) {
  var transformations = mapEdgesToTransformations(edges);

  return _pipe2.default.apply(null, transformations)(graph);
};